## google-compute-engine-oslogin 20200925.00

=== debian/changelog ===
google-compute-engine-oslogin (20200925.00-0ubuntu3~18.04.0) bionic; urgency=medium

  * Rebuild for Bionic
  * Require debhelper 10 only with compat level 10

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 13 Oct 2020 23:17:45 +0200

google-compute-engine-oslogin (20200925.00-0ubuntu3) groovy; urgency=medium

  * New upstream version 20200925.00 (LP: #1899629)
    - Support security key generated OTP challenges
  * Update shared library symlinks

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 13 Oct 2020 15:26:47 +0200

google-compute-engine-oslogin (20200507.00-0ubuntu2) groovy; urgency=medium

  * Set debhelper-compat version in Build-Depends and bump it to 12
  * debian/rules: Don't use --with=systemd, it is default the with
    compat level 10 and up.
  * debian/control: Bump Standards-Version, no changes were required

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 04 Aug 2020 08:41:39 +0200

google-compute-engine-oslogin (20200507.00-0ubuntu1) groovy; urgency=medium

  * Switch to new upstream repository of split off oslogin, rename the
    source package and ship only oslogin (LP: #1885905)
  * New upstream version 20200507.00
  * Refresh patches
  * Update packaging to build and ship only OS Login
  * debian/changelog: Add missing changelog entries

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 23 Jul 2020 15:49:57 +0200

gce-compute-image-packages (20190801-0ubuntu5) groovy; urgency=medium

  * Disable automatic adding of groups to all users (LP: #1878654)
    - d/p/0006-Remove-OS-Login-users-from-admin-groups.-29.patch: remove
      adm, docker, and lxd groups
    - d/p/0007-Remove-local-user-groups-for-OS-Login-users.-30.patch:
      remove dip and plugdev groups

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 14 May 2020 15:25:37 -0700

gce-compute-image-packages (20190801-0ubuntu4) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 11:01:26 +0000

gce-compute-image-packages (20190801-0ubuntu3) focal; urgency=medium

  * Stop build the Python2 packages.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jan 2020 18:33:02 +0100

gce-compute-image-packages (20190801-0ubuntu2) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:33:32 +0000

gce-compute-image-packages (20190801-0ubuntu1~18.04.1) bionic; urgency=medium

  * Disable automatic adding of groups to all users (LP: #1878654)
    - d/p/0006-Remove-OS-Login-users-from-admin-groups.-29.patch: remove
      adm, docker, and lxd groups
    - d/p/0007-Remove-local-user-groups-for-OS-Login-users.-30.patch:
      remove dip and plugdev groups

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 14 May 2020 16:44:15 -0700

gce-compute-image-packages (20190801-0ubuntu1~18.04.0) bionic; urgency=medium

  * Rebuild for Bionic

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 15 Aug 2019 21:57:58 +0200

gce-compute-image-packages (20190801-0ubuntu1) eoan; urgency=medium

  * New upstream version 20190801 (LP: #1840245)
    - Add manpages for NSS modules
    - Switch to the v1 Guest Attributes URL
    - Support Google Private Access over IPv6
  * Refresh patches
  * Fix running tests
  * Keep setting multiarch libdir with the changes upstream Makefiles
  * Update shared library symlinks
  * Don't try to set noop scheduler for partitions (LP: #1833660)

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 15 Aug 2019 19:36:10 +0200

gce-compute-image-packages (20190522-0ubuntu2) eoan; urgency=medium

  * Rebuild against new libjson-c4.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Jun 2019 13:58:02 +0200

gce-compute-image-packages (20190522-0ubuntu1~18.04.0) bionic; urgency=medium

  * Rebuild for Bionic

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 03 Jun 2019 12:41:41 +0200

gce-compute-image-packages (20190522-0ubuntu1) eoan; urgency=medium

  * New upstream version 20190522 (LP: #1831436)
    - Encode hostkey value to utf-8 (needed for Python 3)
  * Update shared library symlinks

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 03 Jun 2019 11:35:43 +0200

gce-compute-image-packages (20190521-0ubuntu1~18.04.0) bionic; urgency=medium

  * Rebuild for Bionic

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 23 May 2019 13:29:21 +0200

gce-compute-image-packages (20190521-0ubuntu1) eoan; urgency=medium

  * New upstream version 20190521 (LP: #1830194)
    - Fix pam_group ordering detection
    - Restart cron on OS Login control
    - Add PAM entry to su:account stack
    - Retry download for metadata scripts
    - Fix script retrieval in python3
    - Disable boto config in python3
    - Update SSH host keys in guest attributes.
    - Fix XPS settings with more than 64 vCPUs
  * Update shared library symlinks

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 22 May 2019 18:53:01 +0200

gce-compute-image-packages (20190315-0ubuntu1~18.04.0) bionic; urgency=medium

  * Rebuild for Bionic.

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 22 Apr 2019 14:11:21 +0200

gce-compute-image-packages (20190315-0ubuntu1) eoan; urgency=medium

  * New upstream version 20190315 (LP: #1824212)
    - Reorganize source tree
    - Use pam_group with OS Login
    - Set oom_score_adjust for google-accounts daemon
    - Restrict permissions for google-oslogin sudoers
    - Add OS Login support for Google prompt challenges
    - Bug fixes
  * Refresh patches
  * Adjust packaging to upstream tree reorganization
  * Ship google_set_hostname as a command, not just as an dhclient exit hook
    matching upstream's choice
  * Don't ship journalctl configuration snippet to forward log to console
  * Update shared library symlinks
  * Ignore absolute symlinks in the source package to keep Lintian happy

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 22 Apr 2019 13:57:26 +0200

gce-compute-image-packages (20190124+dfsg1-0ubuntu1~18.04.0) bionic; urgency=medium

  * Rebuild for Bionic



## google-compute-engine-oslogin 20210122.00

=== src/Makefile ===
SHELL = /bin/sh
TOPDIR = $(realpath ..)

CPPFLAGS = -Iinclude -I/usr/include/json-c
FLAGS = -fPIC -Wall -g
CFLAGS = $(FLAGS) -Wstrict-prototypes
CXXFLAGS = $(FLAGS)

LDFLAGS = -shared -Wl,-soname,$(SONAME)
LDLIBS = -lcurl -ljson-c
PAMLIBS = -lpam $(LDLIBS)

# Paths which should be overrideable.

PREFIX = /usr
LIBDIR = $(PREFIX)/lib
BINDIR = $(PREFIX)/bin
PAMDIR = $(LIBDIR)/security
MANDIR = /usr/share/man
CRONDIR = /etc/cron.d
SYSTEMDDIR = /lib/systemd/system
PRESETDIR = /lib/systemd/system-preset

NSS_OSLOGIN_SONAME       = libnss_oslogin.so.2
NSS_CACHE_OSLOGIN_SONAME = libnss_cache_oslogin.so.2

NSS_OSLOGIN              = libnss_oslogin-$(VERSION).so
NSS_CACHE_OSLOGIN        = libnss_cache_oslogin-$(VERSION).so

PAM_LOGIN                = pam_oslogin_login.so
PAM_ADMIN                = pam_oslogin_admin.so

BINARIES = google_oslogin_nss_cache google_authorized_keys

all : $(NSS_OSLOGIN) $(NSS_CACHE_OSLOGIN) $(PAM_LOGIN) $(PAM_ADMIN) $(BINARIES)

clean :
	rm -f $(BINARIES)
	find . -type f \( -iname '*.o' -o -iname '*.so' \) -delete

.PHONY : all clean install

# NSS modules.

$(NSS_OSLOGIN) : SONAME = $(NSS_OSLOGIN_SONAME)
$(NSS_OSLOGIN) : nss/nss_oslogin.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ -o $@ $(LDLIBS)

$(NSS_CACHE_OSLOGIN) : SONAME = $(NSS_CACHE_OSLOGIN_SONAME)
$(NSS_CACHE_OSLOGIN) : nss/nss_cache_oslogin.o nss/compat/getpwent_r.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ -o $@ $(LDLIBS)

# PAM modules

$(PAM_LOGIN) : pam/pam_oslogin_login.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -shared $^ -o $@ $(PAMLIBS)

$(PAM_ADMIN) : pam/pam_oslogin_admin.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -shared $^ -o $@ $(PAMLIBS)

# Utilities.

google_authorized_keys : authorized_keys/authorized_keys.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

google_oslogin_nss_cache: cache_refresh/cache_refresh.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

install: all
	# Make dirs
	install -d $(DESTDIR)$(LIBDIR)
	install -d $(DESTDIR)$(PAMDIR)
	install -d $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man8
	# NSS modules
	install -m 0644 -t $(DESTDIR)$(LIBDIR) $(NSS_OSLOGIN) $(NSS_CACHE_OSLOGIN)
	ln -sf $(NSS_OSLOGIN)         $(DESTDIR)$(LIBDIR)/$(NSS_OSLOGIN_SONAME)
	ln -sf $(NSS_CACHE_OSLOGIN)   $(DESTDIR)$(LIBDIR)/$(NSS_CACHE_OSLOGIN_SONAME)
	# PAM modules
	install -m 0644 -t $(DESTDIR)$(PAMDIR) $(PAM_ADMIN) $(PAM_LOGIN)
	# Control file
	install -m 0755 -t $(DESTDIR)$(BINDIR) $(BINARIES) $(TOPDIR)/google_oslogin_control
	# Manpages
	install -m 0644 -t $(DESTDIR)$(MANDIR)/man8 $(TOPDIR)/man/nss-oslogin.8 $(TOPDIR)/man/nss-cache-oslogin.8
	gzip -9 $(DESTDIR)$(MANDIR)/man8/nss-oslogin.8
	gzip -9 $(DESTDIR)$(MANDIR)/man8/nss-cache-oslogin.8
	ln -sf nss-oslogin.8.gz       $(DESTDIR)$(MANDIR)/man8/$(NSS_OSLOGIN_SONAME).8.gz
	ln -sf nss-cache-oslogin.8.gz $(DESTDIR)$(MANDIR)/man8/$(NSS_CACHE_OSLOGIN_SONAME).8.gz
ifdef INSTALL_SELINUX
	# SELinux policy package
	install -d $(DESTDIR)/usr/share/selinux/packages
	install -m 0644 -t $(DESTDIR)/usr/share/selinux/packages $(TOPDIR)/selinux/oslogin.pp
endif
ifdef INSTALL_CRON
	# Cache refresh cron
	install -d $(DESTDIR)$(CRONDIR)
	install -m 0644 $(TOPDIR)/cron.d $(DESTDIR)$(CRONDIR)/google-compute-engine-oslogin
else
	# Cache refresh systemd timer
	install -d $(DESTDIR)$(SYSTEMDDIR)
	install -m 0644 -t $(DESTDIR)$(SYSTEMDDIR) $(TOPDIR)/google-oslogin-cache.timer $(TOPDIR)/google-oslogin-cache.service
	install -d $(DESTDIR)$(PRESETDIR)
	install -m 0644 -t $(DESTDIR)$(PRESETDIR) $(TOPDIR)/90-google-compute-engine-oslogin.preset
endif

=== test/Makefile ===
TOPDIR = $(realpath ..)

ifeq ($(GTEST_DIR),)
GTEST_DIR = /usr/src/googletest/googletest/
endif

TEST_RUNNER = ./test_runner --gtest_output=xml
NEW_TEST_RUNNER = ./new_test_runner --gtest_output=xml
CPPFLAGS += -I$(TOPDIR)/src/include -I/usr/include/json-c -I$(GTEST_DIR) -isystem $(GTEST_DIR)/include
CXXFLAGS += -g -Wall -Wextra -std=c++11
LDLIBS = -lcurl -ljson-c -lpthread

all : test_runner new_test_runner non_network_tests

clean :
	rm -f test_runner *.o

gtest-all.o : $(GTEST_DIR)/src/gtest-all.cc
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $^

test_runner : oslogin_utils_test.o $(TOPDIR)/src/oslogin_utils.o gtest-all.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

new_test_runner : oslogin_test.o gtest-all.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

new_tests : new_test_runner $(TOPDIR)/src/nss/new_nss_oslogin.c
	$(NEW_TEST_RUNNER) ${GTESTARGS}

non_network_tests : test_runner new_test_runner
	$(TEST_RUNNER) --gtest_filter=*-FindGroupTest.*:GetUsersForGroupTest.*
	$(NEW_TEST_RUNNER) --gtest_filter=ParserTest.*

network_tests : test_runner ping reset
	$(TEST_RUNNER) --gtest_filter=FindGroupTest.*:GetUsersForGroupTest.*

# run as $ make tests GTESTARGS="--gtest_filter=FindGroupTest.*"
alltests : test_runner
	$(TEST_RUNNER) ${GTESTARGS}

ping :
	nc -vzw2 metadata.google.internal 80 >/dev/null 2>&1

reset :
	curl -Ss http://metadata.google.internal/reset >/dev/null 2>&1

.PHONY : all clean alltests ping reset gtest prowtest non_network_tests network_tests

=== debian/changelog ===
google-compute-engine-oslogin (20210122.00-0ubuntu1~16.04.0) xenial; urgency=medium

  * Backport to Xenial with the following remaining changes:
    - Revert to using dh-systemd because Xenial does not have the debhelper
      version making dh-systemd obsolete
    - Revert to compat mode 9 requiring only debhelper 9
    - Build-depend on libboost-regex-dev for regex support
    - Link with boost for regex support
    - Free tests from C++11 constructs to let them being compiled without
      C++11 support

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 25 Jan 2021 11:58:12 +0100

google-compute-engine-oslogin (20210122.00-0ubuntu1) hirsute; urgency=medium

  * debian/gbp.conf: Add basic gbp config
  * New upstream version 20210122.00 (LP: #1913049)
    - call correct function in pwenthelper

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 25 Jan 2021 11:51:32 +0100

google-compute-engine-oslogin (20210108.00-0ubuntu1~16.04.0) xenial; urgency=medium

  * Backport to Xenial with the following remaining changes:
    - Revert to using dh-systemd because Xenial does not have the debhelper
      version making dh-systemd obsolete
    - Revert to compat mode 9 requiring only debhelper 9
    - Build-depend on libboost-regex-dev for regex support
    - Link with boost for regex support
    - Free tests from C++11 constructs to let them being compiled without
      C++11 support

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 14 Jan 2021 09:39:31 +0100

google-compute-engine-oslogin (20210108.00-0ubuntu1) hirsute; urgency=medium

  * New upstream version 20210108.00 (LP: #1911633)
    - Update logic in the cache_refresh binary
  * Update shipped symlinks

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 14 Jan 2021 09:34:22 +0100

google-compute-engine-oslogin (20200925.00-0ubuntu3~16.04.0) xenial; urgency=medium

  * Backport to Xenial with the following remaining changes:
    - Revert to using dh-systemd because Xenial does not have the debhelper
      version making dh-systemd obsolete
    - Revert to compat mode 9 requiring only debhelper 9
    - Build-depend on libboost-regex-dev for regex support
    - Link with boost for regex support
    - Free tests from C++11 constructs to let them being compiled without
      C++11 support
  * Refresh patches

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 14 Oct 2020 17:30:13 +0200

gce-compute-image-packages (20190801-0ubuntu1~16.04.1) xenial; urgency=medium

  * Disable automatic adding of groups to all users (LP: #1878654)
    - d/p/0006-Remove-OS-Login-users-from-admin-groups.-29.patch: remove
      adm, docker, and lxd groups
    - d/p/0007-Remove-local-user-groups-for-OS-Login-users.-30.patch:
      remove dip and plugdev groups

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 14 May 2020 17:05:31 -0700

gce-compute-image-packages (20190801-0ubuntu1~16.04.0) xenial; urgency=medium

  * Rebuild for Xenial
  * Refresh patches

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 15 Aug 2019 22:05:03 +0200

gce-compute-image-packages (20190522-0ubuntu1~16.04.0) xenial; urgency=medium

  * Rebuild for Xenial

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 03 Jun 2019 12:41:41 +0200

gce-compute-image-packages (20190521-0ubuntu1~16.04.0) xenial; urgency=medium

  * Backport to Xenial with the following remaining changes:
    - Revert ordering shutdown scripts after snapd.service.
    - Revert adding /snap/bin to PATH for startup/shutdown scripts
    - Revert to using dh-systemd because Xenial does not have the debhelper
    - Build-depend on libboost-regex-dev for regex support
      version making dh-systemd obsolete
    - Link with boost for regex support
    - Free tests from C++11 constructs to let them being compiled without
      C++11 support

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 23 May 2019 13:29:21 +0200

gce-compute-image-packages (20190315-0ubuntu1~16.04.0) xenial; urgency=medium

  * Backport to Xenial with the following remaining changes:
    - Revert ordering shutdown scripts after snapd.service.
    - Revert adding /snap/bin to PATH for startup/shutdown scripts
    - Revert to using dh-systemd because Xenial does not have the debhelper
    - Build-depend on libboost-regex-dev for regex support
      version making dh-systemd obsolete
    - Link with boost for regex support
    - Free tests from C++11 constructs to let them being compiled without
      C++11 support
  * Refresh patches
  * debian/rules: Work around dh-python ignoring PYBUILD_DIR

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 22 Apr 2019 14:13:57 +0200

gce-compute-image-packages (20190124+dfsg1-0ubuntu1~16.04.0) xenial; urgency=medium

  * Rebuild for Xenial

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 25 Jan 2019 14:38:44 +0700

gce-compute-image-packages (20181206+dfsg1-0ubuntu1~16.04.0) xenial; urgency=medium

  * Backport to Xenial with the following remaining changes:
    - Revert ordering shutdown scripts after snapd.service.
    - Revert adding /snap/bin to PATH for startup/shutdown scripts
    - Revert to using dh-systemd because Xenial does not have the debhelper
    - Build-depend on libboost-regex-dev for regex support
      version making dh-systemd obsolete
    - Link with boost for regex support
    - Free tests from C++11 constructs to let them being compiled without
      C++11 support
  * Simply add -lboost_regex to LIBS instead of fixing Makefile and passing it
    from debian/rules. Setting -Wl,-z,defs broke the prior solution and
    upstreaming the Makefile fix did not go smooth anyway.

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 07 Jan 2019 14:50:42 +0700

gce-compute-image-packages (20180905+dfsg1-0ubuntu1~16.04.1) xenial; urgency=medium

  * debian/patches/set-LDFLAGS-for-PAM.patch: Fix missing symbols
    when using oslogin due to misording of the boost regex library
    in linking the PAM modules. (LP: #1798706)

 -- Daniel Axtens <daniel.axtens@canonical.com>  Fri, 19 Oct 2018 12:35:45 +1100



=== debian/control ===
Source: google-compute-engine-oslogin
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Section: admin
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               dh-systemd,
               libboost-regex-dev,
               libcurl4-openssl-dev,
               libgtest-dev,
               libjson-c-dev,
               libpam-dev
Standards-Version: 4.5.0
Vcs-Browser: https://code.launchpad.net/~ubuntu-core-dev/+git/gce-compute-image-packages
Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/+git/gce-compute-image-packages -b ubuntu/master
Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages
XSBC-Original-Maintainer: Daniel Watkins <daniel.watkins@canonical.com>

Package: google-compute-engine-oslogin
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         openssh-server
Description: Google Compute Engine OS Login
 Contains libraries, applications and configurations for using OS Login
 on Google Compute Engine Virtual Machine Instances.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export VERSION=$(shell dpkg-parsechangelog -S Version | sed 's/-.*//')

%:
	dh $@ --with systemd

override_dh_auto_configure:
	cp -r /usr/src/gtest/ ./
	dh_auto_configure

override_dh_auto_test:
	(cd gtest && cmake . && $(MAKE) )
	make -C test CXXFLAGS="$(CXXFLAGS) -I$(CURDIR)/gtest" GTEST_DIR=$(CURDIR)/gtest

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/google-compute-engine-oslogin LIBDIR=/lib PAMDIR=/lib/$(DEB_HOST_MULTIARCH)/security install

override_dh_installsystemd:
	dh_installsystemd google-oslogin-cache.timer

override_dh_clean:
	dh_clean gtest/

## google-compute-engine-oslogin 20210429.00

=== test/Makefile ===
--- 
+++ 
@@ -28,13 +28,13 @@
 	$(NEW_TEST_RUNNER) ${GTESTARGS}
 
 non_network_tests : test_runner new_test_runner
-	$(TEST_RUNNER) --gtest_filter=*-FindGroupTest.*:GetUsersForGroupTest.*
+	$(TEST_RUNNER) --gtest_filter=*-GetGroupByTest.*:GetUsersForGroupTest.*
 	$(NEW_TEST_RUNNER) --gtest_filter=ParserTest.*
 
 network_tests : test_runner ping reset
-	$(TEST_RUNNER) --gtest_filter=FindGroupTest.*:GetUsersForGroupTest.*
+	$(TEST_RUNNER) --gtest_filter=GetGroupByTest.*:GetUsersForGroupTest.*
 
-# run as $ make tests GTESTARGS="--gtest_filter=FindGroupTest.*"
+# run as $ make tests GTESTARGS="--gtest_filter=GetGroupByTest.*"
 alltests : test_runner
 	$(TEST_RUNNER) ${GTESTARGS}

=== debian/changelog ===
google-compute-engine-oslogin (20210429.00-0ubuntu1~20.10.0) groovy; urgency=medium

  * Backport to Groovy

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 18 May 2021 20:39:32 +0200

google-compute-engine-oslogin (20210429.00-0ubuntu1) impish; urgency=medium

  * New upstream version 20210429.00 (LP: #1928856)

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 18 May 2021 20:28:49 +0200

google-compute-engine-oslogin (20210122.00-0ubuntu1~20.10.0) groovy; urgency=medium

  * Backport to Groovy

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 25 Jan 2021 11:58:12 +0100

google-compute-engine-oslogin (20210108.00-0ubuntu1~20.10.0) groovy; urgency=medium

  * Backport to Groovy

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 14 Jan 2021 12:38:30 +0100

## google-compute-engine-oslogin 20210728.00

=== debian/changelog ===
google-compute-engine-oslogin (20210728.00-0ubuntu1~20.04.0) focal; urgency=medium

  * No-change rebuild for Focal. (LP: #1938289)

 -- Utkarsh Gupta <utkarsh.gupta@canonical.com>  Fri, 03 Sep 2021 14:53:44 +0530

google-compute-engine-oslogin (20210728.00-0ubuntu1) impish; urgency=medium

  * New upstream version 20210728.00. (LP: #1938289)
    - use IP address for calling the metadata server (#63).
    - throw exceptions in cache_refresh (#64).
    - JSON object cleanup (#65).
  * d/p/0002-fix-double-free-in-ParseJSONToKey.patch: Add
    patch to fix double free in ParseJsonToKey.
  * d/links: Update links w/ respective .so shipped.

 -- Utkarsh Gupta <utkarsh.gupta@canonical.com>  Thu, 05 Aug 2021 18:16:41 +0530

google-compute-engine-oslogin (20210618.00-0ubuntu1) impish; urgency=medium

  * New upstream version 20210618.00. (LP: #1938289)
    - flush each group member write (#62).
  * d/links: Update links w/ respective .so shipped.
  * d/s/lintian-overrides: Comment out old overrides.

 -- Utkarsh Gupta <utkarsh.gupta@canonical.com>  Wed, 28 Jul 2021 19:05:44 +0530

## google-compute-engine-oslogin 20210907.00

=== src/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 PAM_LOGIN                = pam_oslogin_login.so
 PAM_ADMIN                = pam_oslogin_admin.so
 
-BINARIES = google_oslogin_nss_cache google_authorized_keys
+BINARIES = google_oslogin_nss_cache google_authorized_keys google_authorized_keys_sk
 
 all : $(NSS_OSLOGIN) $(NSS_CACHE_OSLOGIN) $(PAM_LOGIN) $(PAM_ADMIN) $(BINARIES)
 
@@ -61,6 +61,9 @@
 # Utilities.
 
 google_authorized_keys : authorized_keys/authorized_keys.o oslogin_utils.o
+	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)
+
+google_authorized_keys_sk : authorized_keys/authorized_keys_sk.o oslogin_utils.o
 	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)
 
 google_oslogin_nss_cache: cache_refresh/cache_refresh.o oslogin_utils.o

=== test/Makefile ===
--- 
+++ 
@@ -39,9 +39,9 @@
 	$(TEST_RUNNER) ${GTESTARGS}
 
 ping :
-	nc -vzw2 metadata.google.internal 80 >/dev/null 2>&1
+	nc -vzw2 169.254.169.254 80 >/dev/null 2>&1
 
 reset :
-	curl -Ss http://metadata.google.internal/reset >/dev/null 2>&1
+	curl -Ss http://169.254.169.254/reset >/dev/null 2>&1
 
 .PHONY : all clean alltests ping reset gtest prowtest non_network_tests network_tests

=== debian/changelog ===
google-compute-engine-oslogin (20210907.00-1) unstable; urgency=medium

  * Initial release.

 -- Bastian Blank <bastian.blank@credativ.de>  Tue, 21 Sep 2021 12:19:19 +0200

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) PAMDIR=/lib/$(DEB_HOST_MULTIARCH)/security VERSION=$(DEB_VERSION_UPSTREAM)

override_dh_auto_test:
	$(MAKE) alltests

## google-compute-engine-oslogin 20220714.00

=== Makefile ===
all install :
	$(MAKE) -C src $@

alltests non_network_tests network_tests :
	$(MAKE) -C test $@

clean :
	$(MAKE) -C src clean
	$(MAKE) -C test clean

prowbuild : debian_deps all

prowtest : debian_deps non_network_tests
	mv test/test_detail.xml ${ARTIFACTS}/junit.xml

debian_deps :
	apt-get -y install g++ libcurl4-openssl-dev libjson-c-dev libpam-dev \
		googletest && touch $@

.PHONY : all clean install prowbuild prowtest alltests non_network_tests network_tests

=== src/Makefile ===
--- 
+++ 
@@ -81,8 +81,8 @@
 	ln -sf $(NSS_CACHE_OSLOGIN)   $(DESTDIR)$(LIBDIR)/$(NSS_CACHE_OSLOGIN_SONAME)
 	# PAM modules
 	install -m 0644 -t $(DESTDIR)$(PAMDIR) $(PAM_ADMIN) $(PAM_LOGIN)
-	# Control file
-	install -m 0755 -t $(DESTDIR)$(BINDIR) $(BINARIES) $(TOPDIR)/google_oslogin_control
+	# Binaries
+	install -m 0755 -t $(DESTDIR)$(BINDIR) $(BINARIES)
 	# Manpages
 	install -m 0644 -t $(DESTDIR)$(MANDIR)/man8 $(TOPDIR)/man/nss-oslogin.8 $(TOPDIR)/man/nss-cache-oslogin.8
 	gzip -9 $(DESTDIR)$(MANDIR)/man8/nss-oslogin.8

=== debian/changelog ===
google-compute-engine-oslogin (20220714.00-0ubuntu1~18.04.0) bionic; urgency=medium

  * No-change rebuild for Bionic. (LP: #1995620)

 -- Utkarsh Gupta <utkarsh@ubuntu.com>  Fri, 04 Nov 2022 15:40:52 +0100

google-compute-engine-oslogin (20220714.00-0ubuntu1) kinetic; urgency=medium

  * New upstream version 20220714.00. (LP: #1995620)
    - no message if no groups (#78).
    - remove deprecated binary (#79).
    - Reauth error (#81).
    - Fix build for EL9. (#82).
    - pam login: split conditions for logging (#83).
    - strip json-c version symbol (#84).
  * d/links: Update links w/ respective .so shipped.
  * d/lintian-overrides: google_oslogin_control has been deprecated.
  * d/lintian-overrides: update warning message, d'oh.
  * d/copyright: drop superfluous file patterns.

 -- Utkarsh Gupta <utkarsh@ubuntu.com>  Thu, 03 Nov 2022 16:21:52 +0100

google-compute-engine-oslogin (20210907.00-0ubuntu1~18.04.0) bionic; urgency=medium

  * No-change rebuild for Bionic. (LP: #1944718)

 -- Utkarsh Gupta <utkarsh.gupta@canonical.com>  Wed, 06 Oct 2021 17:28:38 +0530

google-compute-engine-oslogin (20210907.00-0ubuntu1) impish; urgency=medium

  * New upstream version 20210907.00. (LP: #1944718)
    - fix packaging for authorized_keys_sk (#68).
    - fix double free in ParseJsonToKey (#70).
    - include cstdlib for exit (#75).
    - use sigaction for signals (#76).
  * d/p/0002-fix-double-free-in-ParseJsonToKey.patch: drop
    patch as it is included in this upstream release.
  * d/links: Update links w/ respective .so shipped
  * d/lintian-overrides: no manpage for google_authorized_keys_sk.

 -- Utkarsh Gupta <utkarsh.gupta@canonical.com>  Thu, 23 Sep 2021 16:45:25 +0530

google-compute-engine-oslogin (20210728.00-0ubuntu1~18.04.0) bionic; urgency=medium

  * No-change rebuild for Bionic. (LP: #1938289)
    - Lower dh-compat to 11.

 -- Utkarsh Gupta <utkarsh.gupta@canonical.com>  Fri, 03 Sep 2021 14:25:50 +0530

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,7 @@
 Section: admin
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 9),
-               dh-systemd,
-               libboost-regex-dev,
+               debhelper (>= 11),
                libcurl4-openssl-dev,
                libgtest-dev,
                libjson-c-dev,

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts=\
compression=xz,\
dversionmangle=s/[-.+~]?(git|snapshot|repack|dfsg)(.*)$//i,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/google-compute-engine-oslogin-$1\.tar\.gz/ \
 https://github.com/GoogleCloudPlatform/guest-oslogin/tags .*/v?(\d\S*)\.tar\.gz

## google-compute-engine-oslogin 20231004.00

=== src/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 SHELL = /bin/sh
 TOPDIR = $(realpath ..)
 
-CPPFLAGS = -Iinclude -I/usr/include/json-c
+CPPFLAGS = -Iinclude -I/usr/include/json-c -I$(TOPDIR)/third_party/include
 FLAGS = -fPIC -Wall -g
 CFLAGS = $(FLAGS) -Wstrict-prototypes
 CXXFLAGS = $(FLAGS)
@@ -28,42 +28,42 @@
 NSS_CACHE_OSLOGIN        = libnss_cache_oslogin-$(VERSION).so
 
 PAM_LOGIN                = pam_oslogin_login.so
-PAM_ADMIN                = pam_oslogin_admin.so
 
-BINARIES = google_oslogin_nss_cache google_authorized_keys google_authorized_keys_sk
+BINARIES = google_oslogin_nss_cache google_authorized_keys google_authorized_keys_sk google_authorized_principals
 
-all : $(NSS_OSLOGIN) $(NSS_CACHE_OSLOGIN) $(PAM_LOGIN) $(PAM_ADMIN) $(BINARIES)
+.PHONY: all clean install
+.DEFAULT_GOAL := all
 
-clean :
+all: $(NSS_OSLOGIN) $(NSS_CACHE_OSLOGIN) $(PAM_LOGIN) $(BINARIES)
+
+clean:
 	rm -f $(BINARIES)
 	find . -type f \( -iname '*.o' -o -iname '*.so' \) -delete
 
-.PHONY : all clean install
-
 # NSS modules.
 
-$(NSS_OSLOGIN) : SONAME = $(NSS_OSLOGIN_SONAME)
-$(NSS_OSLOGIN) : nss/nss_oslogin.o oslogin_utils.o
+$(NSS_OSLOGIN): SONAME = $(NSS_OSLOGIN_SONAME)
+$(NSS_OSLOGIN): nss/nss_oslogin.o oslogin_utils.o
 	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ -o $@ $(LDLIBS)
 
-$(NSS_CACHE_OSLOGIN) : SONAME = $(NSS_CACHE_OSLOGIN_SONAME)
-$(NSS_CACHE_OSLOGIN) : nss/nss_cache_oslogin.o nss/compat/getpwent_r.o oslogin_utils.o
+$(NSS_CACHE_OSLOGIN): SONAME = $(NSS_CACHE_OSLOGIN_SONAME)
+$(NSS_CACHE_OSLOGIN): nss/nss_cache_oslogin.o nss/compat/getpwent_r.o oslogin_utils.o
 	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ -o $@ $(LDLIBS)
 
 # PAM modules
 
-$(PAM_LOGIN) : pam/pam_oslogin_login.o oslogin_utils.o
-	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -shared $^ -o $@ $(PAMLIBS)
-
-$(PAM_ADMIN) : pam/pam_oslogin_admin.o oslogin_utils.o
+$(PAM_LOGIN): pam/pam_oslogin_login.o oslogin_sshca.o oslogin_utils.o include/oslogin_sshca.h
 	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -shared $^ -o $@ $(PAMLIBS)
 
 # Utilities.
 
-google_authorized_keys : authorized_keys/authorized_keys.o oslogin_utils.o
+google_authorized_principals: authorized_principals/authorized_principals.o oslogin_utils.o oslogin_sshca.o include/oslogin_sshca.h
 	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)
 
-google_authorized_keys_sk : authorized_keys/authorized_keys_sk.o oslogin_utils.o
+google_authorized_keys: authorized_keys/authorized_keys.o oslogin_utils.o
+	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)
+
+google_authorized_keys_sk: authorized_keys/authorized_keys_sk.o oslogin_utils.o
 	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)
 
 google_oslogin_nss_cache: cache_refresh/cache_refresh.o oslogin_utils.o
@@ -80,13 +80,13 @@
 	ln -sf $(NSS_OSLOGIN)         $(DESTDIR)$(LIBDIR)/$(NSS_OSLOGIN_SONAME)
 	ln -sf $(NSS_CACHE_OSLOGIN)   $(DESTDIR)$(LIBDIR)/$(NSS_CACHE_OSLOGIN_SONAME)
 	# PAM modules
-	install -m 0644 -t $(DESTDIR)$(PAMDIR) $(PAM_ADMIN) $(PAM_LOGIN)
+	install -m 0644 -t $(DESTDIR)$(PAMDIR) $(PAM_LOGIN)
 	# Binaries
 	install -m 0755 -t $(DESTDIR)$(BINDIR) $(BINARIES)
 	# Manpages
 	install -m 0644 -t $(DESTDIR)$(MANDIR)/man8 $(TOPDIR)/man/nss-oslogin.8 $(TOPDIR)/man/nss-cache-oslogin.8
-	gzip -9 $(DESTDIR)$(MANDIR)/man8/nss-oslogin.8
-	gzip -9 $(DESTDIR)$(MANDIR)/man8/nss-cache-oslogin.8
+	gzip -9f $(DESTDIR)$(MANDIR)/man8/nss-oslogin.8
+	gzip -9f $(DESTDIR)$(MANDIR)/man8/nss-cache-oslogin.8
 	ln -sf nss-oslogin.8.gz       $(DESTDIR)$(MANDIR)/man8/$(NSS_OSLOGIN_SONAME).8.gz
 	ln -sf nss-cache-oslogin.8.gz $(DESTDIR)$(MANDIR)/man8/$(NSS_CACHE_OSLOGIN_SONAME).8.gz
 ifdef INSTALL_SELINUX

=== debian/changelog ===
google-compute-engine-oslogin (20231004.00-0ubuntu5) oracular; urgency=medium

  * d/p/0002-inherit-cflags.patch: inherit environment's build flags
    (LP: #2071665).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 02 Jul 2024 10:15:17 +1200

google-compute-engine-oslogin (20231004.00-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:49:52 +1100

google-compute-engine-oslogin (20231004.00-0ubuntu3) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:24:53 +0000

google-compute-engine-oslogin (20231004.00-0ubuntu2) noble; urgency=medium

  * d/control: There must be a dependency on `google-guest-agent`
    to match the (upstream) Google managed d/control file (LP: #2052438)

 -- Chloé 'kajiya' Smith <chloe.smith@canonical.com>  Thu, 01 Feb 2024 00:06:38 +0000

google-compute-engine-oslogin (20231004.00-0ubuntu1) noble; urgency=medium

  * New upstream version 20231004.00. (LP: #2043001)
  * d/links: Update links w/ respective .so shipped

 -- Utkarsh Gupta <utkarsh@ubuntu.com>  Wed, 08 Nov 2023 10:19:01 +0200

## google-compute-engine-oslogin 20240415.00

=== Makefile ===
.PHONY: all clean install
.PHONY: prowbuild prowtest
.PHONY: alltests non_network_tests network_tests

.DEFAULT_GOAL := all

all install: selinux_module
	$(MAKE) -C src $@

selinux_module:
ifdef INSTALL_SELINUX
	$(MAKE) -C selinux
else
	@echo "Variable INSTALL_SELINUX not defined, skipping selinux module build."
endif

alltests non_network_tests network_tests:
	$(MAKE) -C test $@

clean:
	$(MAKE) -C src clean
	$(MAKE) -C test clean
	rm -f debian_deps debian_build_deps debian_test_deps
	rm -f rhel_deps rhel_build_deps

prowbuild: debian_build_deps all

prowtest: debian_deps non_network_tests
	mv -f test/test_detail.xml ${ARTIFACTS}/junit.xml

debian_deps: debian_build_deps debian_test_deps
	touch $@

debian_build_deps:
	apt-get -y install g++ libcurl4-openssl-dev libjson-c-dev libpam-dev \
	&& touch $@

debian_test_deps:
	apt-get -y install googletest \
	&& touch $@

rhel_deps: rhel_build_deps
	touch $@

rhel_build_deps:
	dnf config-manager --set-enabled crb \
	&& dnf install -y policycoreutils gcc-c++ boost-devel libcurl-devel \
					json-c-devel pam-devel policycoreutils \
	&& touch $@

=== src/Makefile ===
SHELL = /bin/sh
TOPDIR = $(realpath ..)

CPPFLAGS = -Iinclude -I/usr/include/json-c -I$(TOPDIR)/third_party/include
FLAGS = -fPIC -Wall -g
CFLAGS = $(FLAGS) -Wstrict-prototypes
CXXFLAGS = $(FLAGS)

LDFLAGS = -shared -Wl,-soname,$(SONAME)
LDLIBS = -lcurl -ljson-c
PAMLIBS = -lpam $(LDLIBS)

# Paths which should be overrideable.

PREFIX = /usr
LIBDIR = $(PREFIX)/lib
BINDIR = $(PREFIX)/bin
PAMDIR = $(LIBDIR)/security
MANDIR = /usr/share/man
CRONDIR = /etc/cron.d
SYSTEMDDIR = /lib/systemd/system
PRESETDIR = /lib/systemd/system-preset

DEST_LIBDIR = $(LIBDIR)
DEST_BINDIR = $(BINDIR)
DEST_PAMDIR = $(PAMDIR)
DEST_MANDIR = $(MANDIR)
DEST_SELINUX = /usr/share/selinux/packages
DEST_CRONDIR = $(CRONDIR)
DEST_SYSTEMDDIR = $(SYSTEMDDIR)
DEST_PRESETDIR = $(PRESETDIR)

ifneq ($(DESTDIR),)
DEST_LIBDIR = $(DESTDIR)/$(LIBDIR)
DEST_BINDIR = $(DESTDIR)/$(BINDIR)
DEST_PAMDIR = $(DESTDIR)/$(PAMDIR)
DEST_MANDIR = $(DESTDIR)/$(MANDIR)
DEST_SELINUX = $(DESTDIR)/usr/share/selinux/packages
DEST_CRONDIR = $(DESTDIR)/$(CRONDIR)
DEST_SYSTEMDDIR = $(DESTDIR)/$(SYSTEMDDIR)
DEST_PRESETDIR = $(DESTDIR)/$(PRESETDIR)
endif

NSS_OSLOGIN_SONAME       = libnss_oslogin.so.2
NSS_CACHE_OSLOGIN_SONAME = libnss_cache_oslogin.so.2

NSS_OSLOGIN              = libnss_oslogin-$(VERSION).so
NSS_CACHE_OSLOGIN        = libnss_cache_oslogin-$(VERSION).so

PAM_ADMIN                = pam_oslogin_admin.so
PAM_LOGIN                = pam_oslogin_login.so

BINARIES = google_oslogin_nss_cache google_authorized_keys google_authorized_keys_sk google_authorized_principals

.PHONY: all clean install
.DEFAULT_GOAL := all

all: $(NSS_OSLOGIN) $(NSS_CACHE_OSLOGIN) $(PAM_LOGIN) $(PAM_ADMIN) $(BINARIES)

clean:
	rm -f $(BINARIES)
	find . -type f \( -iname '*.o' -o -iname '*.so' \) -delete

# NSS modules.

$(NSS_OSLOGIN): SONAME = $(NSS_OSLOGIN_SONAME)
$(NSS_OSLOGIN): nss/nss_oslogin.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ -o $@ $(LDLIBS)

$(NSS_CACHE_OSLOGIN): SONAME = $(NSS_CACHE_OSLOGIN_SONAME)
$(NSS_CACHE_OSLOGIN): nss/nss_cache_oslogin.o nss/compat/getpwent_r.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ -o $@ $(LDLIBS)

# PAM modules

$(PAM_LOGIN): pam/pam_oslogin_login.o oslogin_sshca.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -shared $^ -o $@ $(PAMLIBS)

$(PAM_ADMIN): pam/pam_oslogin_admin.o oslogin_sshca.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -shared $^ -o $@ $(PAMLIBS)

# Utilities.

google_authorized_principals: authorized_principals/authorized_principals.o oslogin_utils.o oslogin_sshca.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

google_authorized_keys: authorized_keys/authorized_keys.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

google_authorized_keys_sk: authorized_keys/authorized_keys_sk.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

google_oslogin_nss_cache: cache_refresh/cache_refresh.o oslogin_utils.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

install: all
	# Make dirs
	install -d $(DEST_LIBDIR)
	install -d $(DEST_PAMDIR)
	install -d $(DEST_BINDIR)
	install -d $(DEST_MANDIR)/man8
	# NSS modules
	install -m 0644 -t $(DEST_LIBDIR) $(NSS_OSLOGIN) $(NSS_CACHE_OSLOGIN)
	ln -sf $(NSS_OSLOGIN)         $(DEST_LIBDIR)/$(NSS_OSLOGIN_SONAME)
	ln -sf $(NSS_CACHE_OSLOGIN)   $(DEST_LIBDIR)/$(NSS_CACHE_OSLOGIN_SONAME)
	# PAM modules
	install -m 0644 -t $(DEST_PAMDIR) $(PAM_LOGIN) $(PAM_ADMIN)
	# Binaries
	install -m 0755 -t $(DEST_BINDIR) $(BINARIES)
	# Manpages
	install -m 0644 -t $(DEST_MANDIR)/man8 $(TOPDIR)/man/nss-oslogin.8 $(TOPDIR)/man/nss-cache-oslogin.8
	gzip -9f $(DEST_MANDIR)/man8/nss-oslogin.8
	gzip -9f $(DEST_MANDIR)/man8/nss-cache-oslogin.8
	ln -sf nss-oslogin.8.gz       $(DEST_MANDIR)/man8/$(NSS_OSLOGIN_SONAME).8.gz
	ln -sf nss-cache-oslogin.8.gz $(DEST_MANDIR)/man8/$(NSS_CACHE_OSLOGIN_SONAME).8.gz
ifdef INSTALL_SELINUX
	# SELinux policy package
	install -d $(DEST_SELINUX)
	install -m 0644 -t $(DEST_SELINUX) $(TOPDIR)/selinux/oslogin.pp
endif
ifdef INSTALL_CRON
	# Cache refresh cron
	install -d $(DEST_CRONDIR)
	install -m 0644 $(TOPDIR)/cron.d $(DEST_CRONDIR)/google-compute-engine-oslogin
else
	# Cache refresh systemd timer
	install -d $(DEST_SYSTEMDDIR)
	install -m 0644 -t $(DEST_SYSTEMDDIR) $(TOPDIR)/google-oslogin-cache.timer $(TOPDIR)/google-oslogin-cache.service
	install -d $(DEST_PRESETDIR)
	install -m 0644 -t $(DEST_PRESETDIR) $(TOPDIR)/90-google-compute-engine-oslogin.preset
endif

=== test/Makefile ===
TOPDIR = $(realpath ..)

ifeq ($(GTEST_DIR),)
GTEST_DIR = /usr/src/googletest/googletest/
endif

TEST_RUNNER = ./test_runner --gtest_output=xml
NEW_TEST_RUNNER = ./new_test_runner --gtest_output=xml
SSHCA_TEST_RUNNER = ./sshca_runner --gtest_output=xml --gtest_filter="SSHCATests.*"
CPPFLAGS += -I$(TOPDIR)/src/include -I$(TOPDIR)/third_party/include -I/usr/include/json-c -I$(GTEST_DIR) -isystem $(GTEST_DIR)/include
CXXFLAGS += -g -Wall -Wextra
LDLIBS = -lcurl -ljson-c -lpthread

.PHONY: all clean alltests ping reset
.PHONY: gtest prowtest non_network_tests network_tests
.DEFAULT_GOAL := all

all: test_runner new_test_runner non_network_tests

clean :
	rm -f test_runner new_test_runner test_detail.xml *.o

gtest-all.o: $(GTEST_DIR)/src/gtest-all.cc
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $^

test_runner: oslogin_utils_test.o $(TOPDIR)/src/oslogin_utils.o gtest-all.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

sshca_runner: oslogin_sshca_test.o $(TOPDIR)/src/oslogin_utils.o $(TOPDIR)/src/oslogin_sshca.o gtest-all.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

sshca_tests: sshca_runner
	$(SSHCA_TEST_RUNNER)

new_test_runner: oslogin_test.o gtest-all.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

new_tests: new_test_runner $(TOPDIR)/src/nss/new_nss_oslogin.c
	$(NEW_TEST_RUNNER) ${GTESTARGS}

non_network_tests: test_runner new_test_runner
	$(TEST_RUNNER) --gtest_filter=*-GetGroupByTest.*:GetUsersForGroupTest.*
	$(NEW_TEST_RUNNER) --gtest_filter=ParserTest.*

network_tests: test_runner ping reset
	$(TEST_RUNNER) --gtest_filter=GetGroupByTest.*:GetUsersForGroupTest.*

# run as $ make tests GTESTARGS="--gtest_filter=GetGroupByTest.*"
alltests: test_runner
	$(TEST_RUNNER) ${GTESTARGS}

ping:
	nc -vzw2 169.254.169.254 80 >/dev/null 2>&1

reset:
	curl -Ss http://169.254.169.254/reset >/dev/null 2>&1

=== debian/changelog ===
google-compute-engine-oslogin (20240415.00-1) unstable; urgency=medium

  * New upstream release. (closes: #1041130)
  * Move all remaining files to /usr.

 -- Bastian Blank <waldi@debian.org>  Mon, 22 Apr 2024 09:01:53 +0200

=== debian/control ===
Source: google-compute-engine-oslogin
Section: admin
Priority: optional
Maintainer: Debian Cloud Team <team+cloud@tracker.debian.org>
Uploaders:
 Bastian Blank <bastian.blank@credativ.de>
Build-Depends:
 debhelper-compat (= 13),
 libcurl4-openssl-dev,
 libgtest-dev <!nocheck>,
 libjson-c-dev,
 libpam-dev,
Standards-Version: 4.6.0
Homepage: https://cloud.google.com/
Vcs-Browser: https://salsa.debian.org/waldi/google-compute-engine-oslogin
Vcs-Git: https://salsa.debian.org/waldi/google-compute-engine-oslogin.git
Rules-Requires-Root: no

Package: google-compute-engine-oslogin
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Google Compute Engine OS Login
 Contains libraries, applications and configurations for using OS Login
 on Google Compute Engine Virtual Machine Instances.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- \
	LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	PAMDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
	SYSTEMDDIR=/usr/lib/systemd/system \
	PRESETDIR=/usr/lib/systemd/system-preset \
	VERSION=$(DEB_VERSION_UPSTREAM)

override_dh_auto_test:
	$(MAKE) alltests

## google-compute-engine-oslogin 20240701.00

=== selinux/Makefile ===
# SELINUX POLICY
MOD_BASE = oslogin
SELINUX_MODULE_SRC = $(MOD_BASE).te
SELINUX_MOD_FILE = $(MOD_BASE).mod
SELINUX_FC_FILE = $(MOD_BASE).fc
SELINUX_MODULE = $(MOD_BASE).pp

all: $(SELINUX_MODULE)

$(SELINUX_MOD_FILE): $(SELINUX_MODULE_SRC)
	checkmodule -M -m -o $(SELINUX_MOD_FILE) $(SELINUX_MODULE_SRC)

$(SELINUX_MODULE): $(SELINUX_MOD_FILE)
	semodule_package -o $(SELINUX_MODULE) -m  $(SELINUX_MOD_FILE) -f $(SELINUX_FC_FILE)

clean:
	rm -f $(SELINUX_MODULE) $(SELINUX_MOD_FILE)

=== debian/changelog ===
google-compute-engine-oslogin (20240701.00-0ubuntu1~24.04.0) noble; urgency=medium

  * No-change rebuild for Noble.

 -- Chloé 'kajiya' Smith <chloe.smith@canonical.com>  Fri, 26 Jul 2024 15:35:20 +0100

google-compute-engine-oslogin (20240701.00-0ubuntu1) oracular; urgency=medium

  [ Utkarsh Gupta ]
  * d/links: Update links w/ respective .so shipped

  [ Chloé 'kajiya' Smith ]
  * New upstream version for upstream tag 20240320.00. (LP: #2073166)

 -- Chloé 'kajiya' Smith <chloe.smith@canonical.com>  Mon, 15 Jul 2024 17:56:01 +0100

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export VERSION=$(shell dpkg-parsechangelog -S Version | sed 's/-.*//')

%:
	dh $@

override_dh_auto_configure:
	cp -r /usr/src/gtest/ ./
	dh_auto_configure

override_dh_auto_test:
	(cd gtest && cmake . && $(MAKE) )
	make -C test CXXFLAGS="$(CXXFLAGS) -I$(CURDIR)/gtest" GTEST_DIR=$(CURDIR)/gtest

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/google-compute-engine-oslogin LIBDIR=/lib PAMDIR=/lib/$(DEB_HOST_MULTIARCH)/security install

override_dh_installsystemd:
	dh_installsystemd google-oslogin-cache.timer

override_dh_clean:
	dh_clean gtest/

## google-compute-engine-oslogin 20260116.00

=== src/Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 SHELL = /bin/sh
 TOPDIR = $(realpath ..)
 
-CPPFLAGS = -Iinclude -I/usr/include/json-c -I$(TOPDIR)/third_party/include
+CPPFLAGS += -I. -I/usr/include/json-c
 FLAGS = -fPIC -Wall -g
-CFLAGS = $(FLAGS) -Wstrict-prototypes
-CXXFLAGS = $(FLAGS)
+CFLAGS += $(FLAGS) -Wstrict-prototypes
+CXXFLAGS += $(FLAGS)
 
 LDFLAGS = -shared -Wl,-soname,$(SONAME)
 LDLIBS = -lcurl -ljson-c

=== test/Makefile ===
TOPDIR = $(realpath ..)

ifeq ($(GTEST_DIR),)
GTEST_DIR = /usr/src/googletest/googletest/
endif

TEST_RUNNER = ./test_runner --gtest_output=xml
SSHCA_TEST_RUNNER = ./sshca_runner --gtest_output=xml --gtest_filter="SSHCATests.*"
CPPFLAGS += -I$(TOPDIR)/src/include -I/usr/include/json-c -I$(GTEST_DIR) -isystem $(GTEST_DIR)/include
CXXFLAGS += -g -Wall -Wextra
LDLIBS = -lcurl -ljson-c -lpthread

.PHONY: all clean alltests ping reset
.PHONY: gtest prowtest non_network_tests network_tests
.DEFAULT_GOAL := all

all : test_runner non_network_tests

clean :
	rm -f test_runner test_detail.xml *.o

gtest-all.o: $(GTEST_DIR)/src/gtest-all.cc
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $^

test_runner: oslogin_utils_test.o $(TOPDIR)/src/oslogin_utils.o gtest-all.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

sshca_runner: oslogin_sshca_test.o $(TOPDIR)/src/oslogin_utils.o $(TOPDIR)/src/oslogin_sshca.o gtest-all.o
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $^ -o $@ $(LDLIBS)

sshca_tests: sshca_runner
	$(SSHCA_TEST_RUNNER)

non_network_tests: test_runner
	$(TEST_RUNNER) --gtest_filter=*-GetGroupByTest.*:GetUsersForGroupTest.*

network_tests: test_runner ping reset
	$(TEST_RUNNER) --gtest_filter=GetGroupByTest.*:GetUsersForGroupTest.*

# run as $ make tests GTESTARGS="--gtest_filter=GetGroupByTest.*"
alltests: test_runner
	$(TEST_RUNNER) ${GTESTARGS}

ping:
	nc -vzw2 169.254.169.254 80 >/dev/null 2>&1

reset:
	curl -Ss http://169.254.169.254/reset >/dev/null 2>&1

=== debian/changelog ===
google-compute-engine-oslogin (20260116.00-0ubuntu1) resolute; urgency=medium

  * New upstream version for 20260116.00 (LP: #2139302)
    * Upstream issue #139 was also resolved so
      d/p/0002-inherit-cflags.patch is no longer needed.
      Also refreshed d/p/0001-set-LDFLAGS-to-prevent-undefs.patch

 -- Chloé 'kajiya' Smith <chloe.smith@canonical.com>  Wed, 28 Jan 2026 16:26:53 +0000

google-compute-engine-oslogin (20240701.00-0ubuntu2) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@ubuntu.com>  Sat, 06 Dec 2025 11:08:15 +0100
